Bug 1747574 - Review Request: python-cocotb - Coroutine Co-simulation Test Bench
Summary: Review Request: python-cocotb - Coroutine Co-simulation Test Bench
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-08-30 20:56 UTC by Ben Rosser
Modified: 2019-10-03 01:05 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-10-03 00:36:47 UTC
loganjerry: fedora-review+


Attachments (Terms of Use)

Description Ben Rosser 2019-08-30 20:56:48 UTC
Spec URL: https://tc01.fedorapeople.org/python/cocotb/cocotb.spec
SRPM URL: https://tc01.fedorapeople.org/python/cocotb/cocotb-1.2.0-1.fc30.src.rpm

Description:
cocotb is a coroutine based cosimulation library for writing VHDL
and Verilog testbenches in Python.

Fedora Account System Username: tc01

This is a Python package, but I've opted to call it "cocotb" and not "python-cocotb" because it's not a standard Python library: it's a verification framework for embedding Python inside a Verilog/VHDL simulator at runtime.

As a result it ships with a bunch of C code (and triggers a "devel-file-in-non-devel-package") warning. But these aren't really "devel" files here: the way cocotb is used, at present, is that the libraries for the simulator get rebuilt when you start the simulation. So they are always needed.

I've made the package "noarch" even though it contains this source code, as the libraries aren't built at compile/install time-- only at run time. I am not totally sure this is correct. I can certainly change the package to be arched (especially as there is some upstream discussion about making it possible to ship prebuilt libraries) if that is the right thing to do.

cocotb _can_ be used with proprietary Verilog/VHDL simulators. But it also is fully usable with the open-source ones (iverilog and ghdl, which are Recommended by the package). To that end, I think it is acceptable for Fedora; it doesn't need the proprietary ones to work.

cocotb fully supports Python 3. :)

Comment 1 Jerry James 2019-09-17 18:49:38 UTC
I can take this review.  I'll have something later tonight to ask you to review.  It should be really easy; it's a header-only development library.

Comment 2 Jerry James 2019-09-17 20:04:19 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- About the name of the package, you have asserted that this is not a standard
  python library.  Yet I look at the tests and the examples, and I see
  "import cocotb".  I look at the final RPM, and I see a python module plus one
  binary, /usr/bin/cocotb-config, which certainly does not sound like the name
  of an application.  This sure looks like a Python module.  I think it should
  have the "python-" prefix.

- The "noarch" tag simply means that the exact same files are installed on
  every architecture, so that is the right thing to do for now.  If upstream
  does decide to ship prebuilt libraries, then you'll have to change that.
  Even then, though, I would argue for making the main package contain only
  the arch-specific bits, and have a noarch subpackage that contains the noarch
  bits.

- This line is unnecessary:

  Requires:       python3dist(setuptools)

  If you run "rpm -q --requires" on the binary rpm, you will see something like
  this among the results (this is for a Rawhide build):

  python3.8dist(setuptools)

  See https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_automatically_generated_dependencies

- These lines in %prep confuse me:

  # Remove bundled egg-info
  rm -rf %{pypi_name}.egg-info

  There is no such directory in the upstream tarball.  Even if there were, it
  would be egg metadata, not an egg package, so not necesssary to remove.  See
  https://docs.fedoraproject.org/en-US/packaging-guidelines/Python_Eggs/#_upstream_egg_packages

- For the change to the shebang in bin/combine_results.py, in addition to
  changing from unversioned python to python3, also get rid of /usr/bin/env,
  perhaps like this:

  sed 's/env python/python3/g' -i bin/combine_results.py

- You might want to tell upstream about python 3.8 incompatibilities (seen in
  the build log):

  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_closedown/test_closedown.py:44: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while test_count is not 5:

  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:296: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while count is not 100:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:397: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while count is not 50:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:406: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while count is not 50:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:545: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 1:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:550: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 0:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:555: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 1:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:560: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 0:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:565: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 1:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_cocotb/test_cocotb.py:570: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if dut.clk.value.integer is not 0:

  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_discovery/test_discovery.py:178: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if length is not 1:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_discovery/test_discovery.py:355: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if length is not 1:

  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_external/test_external.py:57: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while test_count is not 5:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_external/test_external.py:67: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    while test_count is not 5:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_external/test_external.py:118: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if test_count is not 5:
  /builddir/build/BUILD/cocotb-1.2.0/tests/test_cases/test_external/test_external.py:140: SyntaxWarning: "is not" with a literal. Did you mean "!="?
    if test_count is not 5:

  ./bin/combine_results.py:55: DeprecationWarning: This method will be removed in future versions.  Use 'tree.iter()' or 'list(tree.iter())' instead.
    for ts in tree.getiterator("testsuite"):


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License", "BSD 2-clause "Simplified" License", "Expat License",
     "Apache License (v2.0)", "GNU General Public License (v2)". 127 files
     have unknown license.

     This is okay because the non-BSD licensed files are all test or example
     files that are not included in the binary RPM.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package

     There are development files in the main package, but that is because they
     are needed at runtime, so this is okay.

[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.

     I am not convinced this should not be python-cocotb.  See above.

[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cocotb-1.2.0-1.fc32.noarch.rpm
          cocotb-1.2.0-1.fc32.src.rpm
cocotb.noarch: W: spelling-error Summary(en_US) Coroutine -> Co routine, Co-routine, Routine
cocotb.noarch: W: spelling-error %description -l en_US coroutine -> co routine, co-routine, routine
cocotb.noarch: W: spelling-error %description -l en_US cosimulation -> co simulation, co-simulation, simulation
cocotb.noarch: W: spelling-error %description -l en_US testbenches -> test benches, test-benches, frontbenches
cocotb.noarch: W: devel-file-in-non-devel-package /usr/bin/cocotb-config
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/cocotb_utils.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/embed.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/gpi.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/gpi_logging.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/sv_vpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vhpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vpi_user_ext.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/compat/python3_compat.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/embed/gpi_embed.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliImpl.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliObjHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/GpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/GpiCommon.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/gpi_priv.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi_log/gpi_logging.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule_python2.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule_python3.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/utils/cocotb_utils.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiImpl.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiImpl.h
cocotb.noarch: W: no-manual-page-for-binary cocotb-config
cocotb.src: W: spelling-error Summary(en_US) Coroutine -> Co routine, Co-routine, Routine
cocotb.src: W: spelling-error %description -l en_US coroutine -> co routine, co-routine, routine
cocotb.src: W: spelling-error %description -l en_US cosimulation -> co simulation, co-simulation, simulation
cocotb.src: W: spelling-error %description -l en_US testbenches -> test benches, test-benches, frontbenches
2 packages and 0 specfiles checked; 0 errors, 39 warnings.




Rpmlint (installed packages)
----------------------------
cocotb.noarch: W: spelling-error Summary(en_US) Coroutine -> Co routine, Co-routine, Routine
cocotb.noarch: W: spelling-error %description -l en_US coroutine -> co routine, co-routine, routine
cocotb.noarch: W: spelling-error %description -l en_US cosimulation -> co simulation, co-simulation, simulation
cocotb.noarch: W: spelling-error %description -l en_US testbenches -> test benches, test-benches, frontbenches
cocotb.noarch: W: devel-file-in-non-devel-package /usr/bin/cocotb-config
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/cocotb_utils.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/embed.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/gpi.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/gpi_logging.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/sv_vpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vhpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vpi_user.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/include/vpi_user_ext.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/compat/python3_compat.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/embed/gpi_embed.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliImpl.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/fli/FliObjHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/GpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/GpiCommon.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi/gpi_priv.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/gpi_log/gpi_logging.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule_python2.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/simulator/simulatormodule_python3.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/utils/cocotb_utils.c
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vhpi/VhpiImpl.h
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiCbHdl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiImpl.cpp
cocotb.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.8/site-packages/cocotb/share/lib/vpi/VpiImpl.h
cocotb.noarch: W: no-manual-page-for-binary cocotb-config
1 packages and 0 specfiles checked; 0 errors, 36 warnings.



Source checksums
----------------
https://github.com/cocotb/cocotb/archive/v1.2.0/cocotb-1.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : 05198252ce2104007ac8cba3c0a5910d7e35dc03b2cc2352540e53f92e3f2ba4
  CHECKSUM(SHA256) upstream package : 05198252ce2104007ac8cba3c0a5910d7e35dc03b2cc2352540e53f92e3f2ba4


Requires
--------
cocotb (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.8dist(setuptools)
    python3dist(setuptools)



Provides
--------
cocotb:
    cocotb
    python-cocotb
    python3.8dist(cocotb)
    python3dist(cocotb)



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -b 1747574 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: fonts, PHP, R, Haskell, Ruby, Ocaml, SugarActivity, C/C++, Perl, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Miro Hrončok 2019-09-17 22:52:59 UTC
This will break with Python 3.10:

%{python3_sitelib}/%{pypi_name}-%{version}-py?.?.egg-info

Comment 4 Ben Rosser 2019-09-18 09:25:47 UTC
Thanks for taking this! Let me know what you'd like me to review in exchange.

> - About the name of the package, you have asserted that this is not a standard
  python library.  Yet I look at the tests and the examples, and I see
  "import cocotb".  I look at the final RPM, and I see a python module plus one
  binary, /usr/bin/cocotb-config, which certainly does not sound like the name
  of an application.  This sure looks like a Python module.  I think it should
  have the "python-" prefix.

Well... while it's true that the Python parts of the code can be imported as a normal Python package, much of the code is only usable when running embedded inside a RTL simulator, which is why I asserted it's not a standard Python library.

I take your point that it's not really an "application", but I think there's still some utility in letting users find it by the upstream name. How would you feel about renaming the package to 'python-cocotb' but keeping 'cocotb' as a provide?

> python3.8dist(setuptools)

Will remove. pyp2rpm still thinks it needs to manually list Python dependencies-- I guess this probably should get updated upstream.

> These lines in %prep confuse me:

Also put in by pyp2rpm automatically, and I didn't bother to remove it. Happy to get rid of it.

> For the change to the shebang in bin/combine_results.py, in addition to
  changing from unversioned python to python3, also get rid of /usr/bin/env,
  perhaps like this:

Will fix.

>  You might want to tell upstream about python 3.8 incompatibilities (seen in
  the build log):

Will pass these on.

> %{python3_sitelib}/%{pypi_name}-%{version}-py?.?.egg-info

This is another pyp2rpm-generated line. It's probably worth getting this fixed in pyp2rpm upstream too (certainly, I have other Python packages with this in my %files list and I'm sure other people do too).

I will fix it here (I guess one simple fix is to change the second "?" to a "*") though.

Comment 5 Jerry James 2019-09-18 14:30:03 UTC
(In reply to Ben Rosser from comment #4)
> Thanks for taking this! Let me know what you'd like me to review in exchange.

Can you take bug 1753084?  It should be an easy review (famous last words).

> I take your point that it's not really an "application", but I think there's
> still some utility in letting users find it by the upstream name. How would
> you feel about renaming the package to 'python-cocotb' but keeping 'cocotb'
> as a provide?

I think that's fine.  I also think that the reason for requiring the "python-" prefix applies to this package, even though it isn't a traditional library.  If there is ever a python 4, then this package will need dual subpackages for python3 and python4 just as much as traditional libraries do.

Comment 6 Ben Rosser 2019-09-24 11:41:28 UTC
Okay, I've submitted a patch upstream to resolve the backwards compatibility / syntax warning problems:

https://github.com/cocotb/cocotb/pull/1123

I believe I've applied all the other comments, including renaming the package accordingly:

Spec URL: https://tc01.fedorapeople.org/python/cocotb/python-cocotb.spec
SRPM URL: https://tc01.fedorapeople.org/python/cocotb/python-cocotb-1.2.0-2.fc30.src.rpm

- Rename package to 'python-cocotb', provide 'cocotb'.
- Remove unnecessary manual dependency on setuptools.
- Remove unnecessary removal of egg info file.
- Change combine_results script to not use "env" to find python3 interpreter
- Change egg info file in files list to use '*' instead of '?' pattern matching.

Comment 7 Miro Hrončok 2019-09-24 12:13:34 UTC
# iverilog and ghdl are the FOSS simulators. cocotb supports both.
# We need them to run the tests.
# It isn't *strictly* necessary to have them installed, though, especially
# since cocotb also supports non-FOSS simulators. Thus, use a weak dep to
# pull them in (but allow someone to remove them if necessary).
Recommends:     iverilog, ghdl
BuildRequires:  iverilog, ghdl


The recommends will not be applied to the python3-cocotb package, but to the python-cocotb package (that is not being created at the end, hence, the recommends are no-op).

Comment 8 Ben Rosser 2019-09-24 12:29:57 UTC
Oops, yes, I forgot to move them into the subpackage (now that there is one).

Fixed:

Spec URL: https://tc01.fedorapeople.org/python/cocotb/python-cocotb.spec
SRPM URL: https://tc01.fedorapeople.org/python/cocotb/python-cocotb-1.2.0-3.fc30.src.rpm

Comment 9 Jerry James 2019-09-24 16:17:32 UTC
Looks good now.  This package is APPROVED.

Comment 10 Gwyn Ciesla 2019-09-24 17:02:07 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-cocotb

Comment 11 Fedora Update System 2019-09-24 19:10:19 UTC
FEDORA-2019-6a358e1044 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-6a358e1044

Comment 12 Fedora Update System 2019-09-24 19:15:22 UTC
FEDORA-2019-f5f5471e99 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-f5f5471e99

Comment 13 Fedora Update System 2019-09-25 01:38:35 UTC
python-cocotb-1.2.0-3.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-6a358e1044

Comment 14 Fedora Update System 2019-09-25 03:40:27 UTC
python-cocotb-1.2.0-3.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-f5f5471e99

Comment 15 Fedora Update System 2019-10-03 00:36:47 UTC
python-cocotb-1.2.0-3.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2019-10-03 01:05:42 UTC
python-cocotb-1.2.0-3.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.